pub mod is_prime {
    use num_bigint::BigUint;
    fn log_2(x: BigUint) -> u64 {
        x.bits() - 1
    }
    
    pub fn is_prime(number: BigUint) -> bool {
        if BigUint::from(1u8) == number {
            return false;
        }
        if BigUint::from(4u8) > number  {
            return true;
        }
    
        let two = BigUint::from(2u8);
    
        // number = 2^a - 1
        // a = log2(number + 1)
        let a = log_2(number.clone()+1u8);
        if BigUint::from(2u8).pow(a as u32)-BigUint::from(1u8) != number {
            //eprintln!("only supports numbers of type (2^x)-1");
            let mut i = BigUint::from(1u8);
            let one = BigUint::from(1u8);
            let zero = BigUint::from(0u8);
            
            let sqrtnum = number.sqrt()+one.clone();
            let mut is_prime = true;
            loop {
                i = i + one.clone();
                if number.clone()%i.clone() == zero {
                    // println!("{number} {i}");
                    is_prime = false;
                    break;
                }
                if i == sqrtnum {
                    break;
                }
            }
            return is_prime;
        }
    
        // 4 12 194
        let mut last = BigUint::from(4u8);
        
        for _i in 2..a {
            last = (last.pow(2)-two.clone())%number.clone();
        }
        if last == BigUint::from(0u8) {
            true
        } else {
            false
        }
    } 
}

